int rawValue;
int ledPin=13;
int analogPin=0;
const int delayMsec = 60; 

#include <SoftwareSerial.h>

#define BT_RX 2
#define BT_TX 3
SoftwareSerial bluetoothSerial(BT_RX, BT_TX);

void setup() {
  pinMode(ledPin,OUTPUT);  
  bluetoothSerial.begin(9600);
  bluetoothSerial.flush();
  Serial.begin(9600);  
  Serial.println("Heartbeat detection example code");
}
    
void loop(){ 
  static int beatMsec = 0;  
  int heartRateBPM = 0;      
  //Serial.println(rawValue);  
  if (heartbeatDetected(analogPin, delayMsec)) { 
     heartRateBPM = 60000 / beatMsec;        
     digitalWrite(ledPin,1);    
     //Serial.print(rawValue);    
     //Serial.print(", ");    
     Serial.println(heartRateBPM);    
     bluetoothSerial.print(heartRateBPM);
     delay(120);
     beatMsec = 0;  } 
  else { 
     digitalWrite(ledPin,0);  } 
  delay(delayMsec);  
  beatMsec += delayMsec;
}

bool heartbeatDetected(int IRSensorPin, int delays) {  
  static int maxValue = 0;  
  static bool isPeak = false;  
  bool result = false;  
  rawValue = analogRead(IRSensorPin);  
  rawValue *= (1000/delays);  
  if (rawValue * 4L < maxValue) {
    maxValue = rawValue * 0.8; }    // Detect new peak 
  if (rawValue > maxValue - (1000/delays)) {    
    if (rawValue > maxValue) {
      maxValue = rawValue;    }    
    if (isPeak == false) {
      result = true;   }   
      isPeak = true;  
    } 
  else if (rawValue < maxValue - (3000/delays)) {
    isPeak = false;    
    maxValue-=(1000/delays); }  
  return result;
}
